#ifndef _C_PACMAN_H
#define _C_PACMAN_H

enum {  MUR = 1,
	POMME,
	POMME_BONUS,

	PACMAN,
	FANTOME };

const int LONGEUR_PLATEAU = 40;		// Longueur et largeur en caractres
const int HAUTEUR_PLATEAU = 20;		//  du plateau de jeu (un niveau ou tableau)

const int DECALLAGE_PLATEAU_X = 1;	// Dcallage entre l'index dans les tableaux
const int DECALLAGE_PLATEAU_Y = 4;	//  et la position des caractres correspondants  l'cran

/*****
 *  Reprsente le pacman (le joueur).
 *  Sera drive pour dfinir un fantme.
 */
class personnage
{
protected:
	int x, y;
	char car;
	bool actif;

public:
	personnage(int x, int y, char car);
	char get_car();
	int get_x();
	int get_y();
	int set_position(int x, int y);
};

/*****
 *  Reprsente un fantme et tout ce qui est ncessaire pour grer son AI.
 */
class fantome : public personnage
{
	personnage *pacman_associe;
	bool s_echape;

public:
	fantome(int x, int y, char car);
	void associer_pacman(personnage * pacman);
	void definir_s_echapper(bool echape);
	void definir_actif(bool activer);
	void definir_chemin();
	void deplacer();
};

/*****
 *  Stoque les donnes correspondantes au plateau de jeu.
 *  Et notemment le nombre de fantmes prsents dans une case donnes.
 *  Ce afin de pouvoir afficher et bien effacer les caractres  l'cran.
 */
class plateau
{
	int niveau[LONGEUR_PLATEAU][HAUTEUR_PLATEAU];
	int fantomes[LONGEUR_PLATEAU][HAUTEUR_PLATEAU];

public:
	bool emplacement_libre(int x, int y, char car);
	void afficher_caractere(int x, int y, char car);
	void effacer_caractere(int x, int y, char car);
	int get_at(int x, int y);
	void set_at(int x, int y, char car);
	int get_fantome(int x, int y);
};

#endif // _C_PACMAN_H
