/*
 *  pacman.cpp : Jeu de PacMan ; un bon entranement pour moi programmer ;-)
 *  Auteur     : Sbastien Laot
 *  Cration   : fin avril 2003
 */

#include <iostream>	// cout
#include <fstream>	// flux de fichiers
#include <stdio.h>	// fflush()
#include <unistd.h>	// usleep()

#include "getch.h"	// Utiliser getchar() comme getch()
#include "pacman.h"	// Fichier d'inclusion du projet
#include "c_pacman.h"	// Les classses du jeu

using std::cout;
using std::ifstream;

/* Dclaration des variables globales du jeu */
plateau niveau;
personnage *pacman;
fantome *fantomes[MAX_FANTOMES];

int count_pommes = 0;
int count_mangees = 0;
unsigned int count_fantomes = 0;

int t_ai = 0;
int bonus = -1;
int direction_x = 0;
int direction_y = 0;

int main(int argc, char *argv[])
{
	/* Variables temporaires */
	char ligne[LONGEUR_PLATEAU];
	unsigned int i, j;

	/* Dcryptage des arguments de la ligne de commande : le nom du niveau */
	if (argc != 2) {
		afficher_usage();
		exit(EXIT_NO_ARG);
	}

	/* Ouverture du fichier niveau */
	ifstream fichier(argv[1]);
	if (!fichier) {
		cout << argv[1] << " : Fichier non trouv\n";
		exit(EXIT_NO_FILE);
	}

	/* Affichage de l'interface */
	init_getch();
	cout << "\033[2J"	// Efface l'cran (le curseur sera noir, donc invisible)
		"\033[1;1H";	// Positionne le curseur en haut  gauche

	/* Affichage des informations gnrales */
	if ( ! fichier.getline(ligne, LONGEUR_PLATEAU + 1))
		fichier_invalide(argv[1]);
	cout << ligne << '\n';			// Nom du niveau
	if ( ! fichier.getline(ligne, LONGEUR_PLATEAU + 1))
		fichier_invalide(argv[1]);
	cout << "Par : " << ligne << "\n\n";	//Nom de l'auteur

	/* Mise en place du plateau et des variables relatives  celui-ci */
	for (i = 0; i < 20; i++) {		// Pour chaque lignes
		if ( ! fichier.getline(ligne, LONGEUR_PLATEAU + 1))
			fichier_invalide(argv[1]);
		for (j = 0; j < strlen(ligne); j++) { // Pour chaque caractres
			switch (ligne[j]) {
				case '.' : // Pommes
					niveau.set_at(j, i, POMME);
					++count_pommes;
					cout << '.';
					break;
				case ';' : // Pommes bonus
					niveau.set_at(j, i, POMME_BONUS);
					cout << ';';
					break;
				case '' : // Fantmes si nombre maximal non dpass
					if (count_fantomes < MAX_FANTOMES) {
						fantomes[count_fantomes] = new fantome(j, i, '');
						if (!fantomes[count_fantomes]) {
							cout << "Plus assez de mmoire\n";
							exit(EXIT_ERR_MEMORY);
						}
						++count_fantomes;
					}
					break;
				case 'c' : // PacMan si pas encore dfini
					if (pacman == NULL)
						pacman = new personnage(j, i, 'c');
					cout << 'c';
					break;
				case ' ' : // Vide
					cout << ' ';
					break;
				default : // Mur et autre dcorations
					cout << ligne[j];
					niveau.set_at(j, i, MUR);
			}
		}
		cout << '\n';
	}
	fichier.close();

	if (pacman == NULL) { //.get_car() != 'c') { // Si pacman n'a pas t plac
		//FIXME: le placer  un emplacement libre
		;
	}

	printf("\033[3;1HPommes : %d\tManges : %d", count_pommes, count_mangees);

	/* Dernires initialisations avant de dmarrer le jeu */
	for (i = 0; i < count_fantomes; ++i)
		fantomes[i]->associer_pacman(pacman);
	printf("\033[1;1H");				// Se dbarasser du curseur

	/* La boucle principale du jeu */
	int touches[3];
	while (1) {
		obtenir_derniere_touche(touches);

		/* [ECHAP] pour quitter */
		if (touches[0] == 27 && touches[1] == 0)
			break;

		/* Dplacer PacMan */
		if (touches[0] == 27 && touches[1] == 91) {
			switch (touches[2]) {
				case 65: direction_x =  0; direction_y = -1; break;	// [haut]
				case 66: direction_x =  0; direction_y =  1; break;	// [Bas]
				case 67: direction_x =  1; direction_y =  0; break;	// [Droit]
				case 68: direction_x = -1; direction_y =  0; break;	// [Gauche]
			}
		}
		int pm_x = pacman->get_x();
		int pm_y = pacman->get_y();
		pm_x += direction_x;
		pm_y += direction_y;

		/* Si dplacement effectu et qu'une pomme s'y trouve */
		if (pacman->set_position(pm_x, pm_y)) {
			if (niveau.get_at(pacman->get_x(), pacman->get_y()) == POMME) {
				niveau.set_at(pm_x, pm_y, 0);
				++count_mangees;
				printf("\033[3;27H%d ", count_mangees);
				cout << "\007";			// Signal sonor
			}
			if (niveau.get_at(pacman->get_x(), pacman->get_y()) == POMME_BONUS) {
				niveau.set_at(pm_x, pm_y, 0);
				for (i = 0; i < count_fantomes; ++i)
					fantomes[i]->definir_s_echapper(1);
				cout << "\007\007";		// Double signal sonor
				bonus += DUREE_BONUS + 1;
			}
		}

		/* Intelligence Artificielle active une fois sur T_AI */
		if ( ! ((++t_ai) % T_AI) )
			for (i = 0; i < count_fantomes; ++i)
				fantomes[i]->deplacer();	// Dplacer les fantmes

		if (niveau.get_fantome(pacman->get_x(), pacman->get_y())) {
			if (bonus < 0) {
				cout << "PERDU!";
				break;
			} else {
				for (i = 0; i < count_fantomes; ++i) {
					if (fantomes[i]->get_x() == pacman->get_x() &&
					    fantomes[i]->get_y() == pacman->get_y())
						fantomes[i]->definir_actif(0);
				}
				niveau.afficher_caractere(pacman->get_x(),
					pacman->get_y(),
					pacman->get_car());
			}
		}

		printf("\033[1;1H");	// Se dbarasser du curseur en le mettant en haut  gauche
		fflush(stdout);		// On affiche bien tout  l'cran (avant la pause)
		usleep(T_SLEEP);	// Pause pour ne pas consommer de CPU inutilement

		if (bonus > 0)
			--bonus;

		if (bonus == 0) {
			bonus = -1;
			for (i = 0; i < count_fantomes; ++i) {
				fantomes[i]->definir_s_echapper(0);
				fantomes[i]->definir_actif(1);
			}
		}

		if (count_mangees == count_pommes) // Si toutes les pommes ont t manges
			break;
	}

	cout << "\033[24;1H";
	end_getch();
	return 0;
}

/*****
 *  Description gnrale de l'application :
 *  Cette fonction affiche simplement l'usage du programme
 *  et les paramtres  donner  la ligne de commande.
 */
void afficher_usage()
{
	cout << "pacman : Jeu de PacMan : un bon entranement pour moi programmer ;-)\n"
		"Usage  : pacman NIVEAU\n"
		"NIVEAU : nom du fichier contenant le niveau\n"
		"         \"nx\" o x vaut le numro du niveau si le fichier est prsent\n";
}

/*****
 *  Cette fonction permet de quitter si le fichier lu n'est pas conforme
 *   ce qui est attendu.
 */
void fichier_invalide(char *fichier)
{
	cout << fichier << " : Fichier de format invalide\n"
		"- 1 ligne : Nom du niveau\n"
		"- 2 ligne : Nom de l'auteur\n"
		"- Puis 20 lignes pour le niveau\n"
		"Chaque ligne devant contenir au maximum 40 caractres.\n";
	exit(EXIT_INVALID_FILE);
}

/*
 *  Routine pour ne garder que la dernire touche presse
 *  (cette touche peut faire un caractre ou trois : cas d'une
 *  squence d'chapement (commenant par 29) comme les flches de directions.
 */
void obtenir_derniere_touche(int *touches) {
	touches[0] = 0;
	touches[1] = 0;
	touches[2] = 0;
	int i_touches = -1;
	int k;

	while ((k = getchar()) != -1) {
		++i_touches;
		if (i_touches == 3) {
			touches[0] = touches[1];
			touches[1] = touches[2];
			i_touches = 2;
		}
		touches[i_touches] = k;
	}

	if (i_touches > -1 && touches[0] != 27) {
		touches[0] = touches[i_touches];
		touches[1] = 0;
		touches[2] = 0;
	}
}
